Description

Seen in STAGE, somehow the index processor generated about 15k tasks (after processing 215k tasks over the weekend) during a
service stop. It also created about 12.5 failures. Before trying to stop services, this the status of postgres:

dl-index—queue=# select status, count (*) from index_task group by status;

status | count
____________ b
NEW | 5
FAILED | 1659
IN PROCESS | 367
(3 rows)

Execution of /etc/init.d/d1-index-task-processor stop timed out.
| performed /etc/init.d/d1-index-task-generator stop successfully, getting an [OK]
then | performed /etc/init.d/d1-processing stop on UCSB, also getting an 'TOK]

examination of the indexing log file a couple minuted later showed this:

[ INFO] 2018-02-12 20:36:08,975 (IndexTaskProcessor:logProcessorLoad:245) new tasks:0, tasks previ
ously failed: 1661

[ INFO] 2018-02-12 20:36:09,361 (IndexTaskProcessor:processFailedIndexTaskQueue:226) IndexTaskProc

essor.processFailedIndexTaskQueue with size 0

[ WARN] 2018-02-12 20:36:09,361 (IndexTaskProcessorJob:execute:58) processing job [org.dataone.cn.
index.processor.IndexTaskProcessorJob@515de84e] finished execution of index task processor [org.da

taone.cn.index.processor.IndexTaskProcessor@2062

1d44]

[ WARN] 2018-02-12 20:36:26,571 (IndexTaskProcessorScheduler:stop:99) stopping index task processo
r quartz scheduler [org.dataone.cn.index.processor.IndexTaskProcessorScheduler@103bbd22]

[ INFO] 2018-02-12 20:36:26,572 (QuartzScheduler:standby:572) Scheduler QuartzScheduler_$_NON_CLUS
TERED paused.

[ INFO] 2018-02-12 20:36:26,572 (IndexTaskProcessorScheduler:stop:111) Scheuler.interrupt method c
an't succeed to interrupt the dl index job and the static method IndexTaskProcessorJob.interruptCu
rrent () will be called.

[ WARN] 2018-02-12 20:36:26,572 (IndexTaskProcessorJob:interruptCurrent:92) IndexTaskProcessorJob
class [1806183035] interruptCurrent called, shutting down processor [org.dataone.cn.index.processo
r.IndexTaskProcessor@20621d44]

[ WARN] 2018-02-12 20:36:26,573 (IndexTaskProcessor:shutdownExecutor:952) processor [org.dataone.c

n.index.processor.IndexTaskProcessor@20621d44] Shutting down the ExecutorService. Will allow acti

ve tasks to finish; will cancel submitted tasks

and return them to NEW status, wait for active tasks to finish, then return any remaining task not
yet submitted to NEW status....

[ WARN] 2018-02-12 20:36:26,573 (IndexTaskProcessor:shutdownExecutor:955) ...1l.) closing ExecutorS
ervice to new tasks...

[ WARN] 2018-02-12 20:36:26,574 (IndexTaskProcessor:shutdownExecutor:957) ...2.) cancelling cancel
lable futures...

[ WARN] 2018-02-12 20:36:26,575 (IndexTaskProcessor:shutdownExecutor:958) ...number of futures: 59
1344

[ WARN] 2018-02-12 20:36:26,575 (IndexTaskProcessor:shutdownExecutor:959) ... number of tasks in f
utures map: 591344

15 minutes or so later, the log showed this:

[ WARN] 2018-02-12 20:36:26,573 (IndexTaskProcessor:shutdownExecutor:955) ...1l.) closing ExecutorS
ervice to new tasks...

[ WARN] 2018-02-12 20:36:26,574 (IndexTaskProcessor:shutdownExecutor:957) ...2.) cancelling cancel
lable futures...

[ WARN] 2018-02-12 20:36:26,575 (IndexTaskProcessor:shutdownExecutor:958) ...number of futures: 59
1344

[ WARN] 2018-02-12 20:36:26,575 (IndexTaskProcessor:shutdownExecutor:959) ... number of tasks in f
utures map: 591344

[ WARN] 2018-02-12 20:52:30,811 (IndexTaskProcessor:shutdownExecutor:988) ...number of (cancellabl
e) runnables/tasks reset to new: 0

[ WARN] 2018-02-12 20:52:30,811 (IndexTaskProcessor:shutdownExecutor:989) ...number of (cancellabl
e) runnables not mapped to tasks: 0

[ WARN] 2018-02-12 20:52:30,811 (IndexTaskProcessor:shutdownExecutor:990) ...number of uncancellab
le runnables: 591344 (completed or in process)

[ WARN] 2018-02-12 20:52:30,812 (IndexTaskProcessor:shutdownExecutor:993) ...3.) waiting (with tim
eout) for active futures to finish...

[ WARN] 2018-02-12 20:52:30,812 (IndexTaskProcessor:shutdownExecutor:998) ...4.) Reviewing remaini
ng uncancellables to check for completion, returning incomplete ones to NEW status...

[ WARN] 2018-02-12 20:52:30,835 (IndexTaskProcessor:shutdownExecutor:1026) ...5.) Calling shutdown
Now on the executor service.

[ WARN] 2018-02-12 20:52:30,835 (IndexTaskProcessor:shutdownExecutor:1028) ... .... number of runn
ables still waiting: O

[ WARN] 2018-02-12 20:52:30,835 (IndexTaskProcessor:shutdownExecutor:1030) ...6.) returning preSub
mitted tasks to NEW status...

[ WARN] 2018-02-12 20:52:30,835 (IndexTaskProcessor:shutdownExecutor:1031) ... .... number of preS

ubmitted tasks: 34735

[ INFO] 2018-02-12 20:52:30,835 (IndexTask:markNew:454) Even tough it was masked new, it is still
considered failed for id testGetPackage_2017119234441164 since it was tried to many times.

[ERROR] 2018-02-12 20:52:30,891 (IndexTaskProcessor:shutdownExecutor:1038) ....... Exception throw
n trying to return task to NEW status for pid: testGetPackage_2017119234441164
org.springframework.orm.hibernate3.HibernateOptimisticLockingFailureException: Object of class [or
g.dataone.cn.index.task.IndexTask] with identifier [13071797]: optimistic locking failed; nested e
xception is org.hibernate.StaleObjectStateException: Row was updated or deleted by another transac
tion (or unsaved-value mapping was incorrect): [org.dataone.cn.index.task.IndexTask#13071797]

[ INFO] 2018-02-12 20:54:19,618 (IndexTask:markNew:454) Even tough it was masked new, it is still
considered failed for id P3_201622214921901 since it was tried to many times.

[ WARN] 2018-02-12 20:54:19,621 (IndexTaskProcessor:shutdownExecutor:1036) ... preSubmittedTask fo
r pid P3_201622214921901returned to NEW status.

[ WARN] 2018-02-12 20:54:19,623 (IndexTaskProcessor:shutdownExecutor:1036) ... preSubmittedTask fo
r pid resource_map_doi:10.5065/D6VD6WFPreturned to NEW status.

[ INFO] 2018-02-12 20:54:19,623 (IndexTask:markNew:454) Even tough it was masked new, it is still

considered failed for id testGetPackage_NotAuthorized_201710605522454 since it was tried to many t
imes.

[ WARN] 2018-02-12 20:54:19,626 (IndexTaskProcessor:shutdownExecutor:1036) ... preSubmittedTask fo
r pid testGetPackage_NotAuthorized_201710605522454returned to NEW status.

[ WARN] 2018-02-12 20:54:19,628 (IndexTaskProcessor:shutdownExecutor:1036) ... preSubmittedTask fo
r pid resource_map_urn:uuid:d3606ccb-2d50-4723-ae45-c0d01b817e48returned to NEW status.

[ WARN] 2018-02-12 20:54:19,631 (IndexTaskProcessor:shutdownExecutor:1036) ... preSubmittedTask fo
r pid resource_map_doi:10.18739/A2165Freturned to NEW status.

[ WARN] 2018-02-12 20:54:19,631 (IndexTaskProcessor:shutdownExecutor:1041) ............ 7.) DONE wi

th shutting down IndexTaskProcessor.

[ INFO] 2018-02-12 20:54:19,631 (IndexTaskProcessorScheduler:stop:113) The scheuler.interrupt meth
od seems not interrupt the dl index job and the static method IndexTaskProcessorJob.interruptCurre
nt () was called.

[ WARN] 2018-02-12 20:54:19,632 (IndexTaskProcessorScheduler:stop:128) Job scheduler [org.dataone.
cn.index.processor.IndexTaskProcessorScheduler@103bbd22] finished executing all jobs. The dl-index
—-processor shut down sucessfully.

2024-03-13 2/3




but postgres yielded this:

dl-index-queue=# select status, count (*) from index_task group by status;

status | count
,,,,,,,, ]
NEW | 15367
FAILED | 14032
(2 rows)

indexer shutdowns are a stubborn problem...

Related issues:
Related to Infrastructure - Story #8702: Indexing Refactor Strategy New 2018-09-24

History

#1 - 2018-09-24 15:22 - Rob Nahf
- Related to Story #8702: Indexing Refactor Strategy added

#2 - 2018-09-24 15:25 - Rob Nahf

the new design will introduce back-pressure so that many fewer tasks are spooled into IN_PROCESS status. It is likely issues in shutdown that
cause new tasks to be created, instead of resetting the status of existing tasks, but the shutdown method should also be reviewed to see why this is
occurring in the first place, even in small numbers.
